package cz.vsb.gisak;
import com.vividsolutions.jts.geom.*;
import com.vividsolutions.jump.feature.*;
import com.vividsolutions.jump.workbench.model.*;
import com.vividsolutions.jump.workbench.ui.renderer.style.Style;
import com.vividsolutions.jump.workbench.ui.Viewport;



import java.awt.*;
import java.awt.geom.*;


public class StyleImage implements Style {
	private String filepath;
	private Envelope envelope;
	private Image image;
	private double minx, maxy;
	
	public String toString() {
		return "cz.vsb.gisak.StyleImage";
	}
	
	
	public Image getImage() {
		return image;
	}
	
	public void setImage(Image i) {
		image = i;
	}
	
	
	public String getFilePath() {
		return filepath;
	}
	
	
	public void setFilePath(String  s) {
		this.filepath=s;
	}
	
	public StyleImage(Envelope envelope, Image image, double minx, double maxy) {
		this.envelope = envelope;
		this.image = image;
		this.minx = minx;
		this.maxy = maxy;
	}
	public void paint(Feature f, Graphics2D g, Viewport viewport) throws Exception {
	    AffineTransform originalTransform;
	    System.out.println("Prekresleno");
	    originalTransform = g.getTransform();
	    try {
	      double xScale, yScale;
	      xScale = viewport.getScale() * envelope.getWidth()/image.getWidth(null);
	      yScale = viewport.getScale() * envelope.getHeight()/image.getHeight(null);
	      g.scale(xScale, yScale);
	      Point2D upperLeftCorner = null;
		try {
	      upperLeftCorner = viewport.toViewPoint(new Coordinate(minx, maxy));
		} catch(java.awt.geom.NoninvertibleTransformException ne) {

		}
	      g.translate(upperLeftCorner.getX()/xScale, upperLeftCorner.getY()/yScale);
	      g.drawImage(image, 0, 0, null);    
	    } 
	    finally {
		g.setTransform(originalTransform);  
	    }
	}

	  public void initialize(Layer layer) {}
	  public Object clone() { throw new UnsupportedOperationException(); }
	  public void setEnabled(boolean enabled) {}
	  public boolean isEnabled() { return true; }

}
