package cz.vsb.gisak.kuc273;

import java.awt.image.*;

//tato trida pouziva pri nastaveni koeficientu gaussovske rozlozeni hodnot
public class GaussianBlur implements DemoImgOp{
    protected float matrix[] =  {1f/256f, 4f/256f, 6f/256f, 4f/256f, 1f/256f,
                       4f/256f, 16f/256f, 24f/256f, 16f/256f, 4f/256f,
                       6f/256f, 24f/256f, 36f/256f, 24f/256f, 6f/256f,
                       4f/256f, 16f/256f, 24f/256f, 16f/256f, 4f/256f,
                       1f/256f, 4f/256f, 6f/256f, 4f/256f, 1f/256f};
    protected ConvolveOp cop;
    public GaussianBlur() {
        Kernel kernel = new Kernel(5,5,matrix);
        cop = new ConvolveOp(kernel, ConvolveOp.EDGE_NO_OP, null);
    }
    public BufferedImage filter(BufferedImage src){
        return cop.filter(src, null);
    }
}