
package cz.vsb.gisak.kuc273;

import java.awt.image.*;

//trida na zamenu barev v obraze
//odecita offset ulozeny v promenne table tridy ByteLookupTable od puvodnich hodnot v obraze
public class ReverseLookUp implements DemoImgOp{
	//pouziti tridy LookupOp, ktera provadi look up filtraci
    protected LookupOp lookup;
    protected ByteLookupTable table;

    public ReverseLookUp() {
        //pole array velikosti 256 dat. typu byte
    	byte array[] = new byte[256];
        //do pole se ulozi sestupne cisla typu byte od 255 do 0
    	for (int i = 0; i < 256; i++)
            array[i] = (byte)(255-i);
        table = new ByteLookupTable(0, array);
        lookup = new LookupOp(table, null);
    }

    public BufferedImage filter(BufferedImage src) {
        return lookup.filter(src, null);
    }
}
