
package cz.vsb.gisak.kuc273;

import java.awt.image.*;
//trida slouzi k ostreni - mirnemu zvyrazneni hran
public class Sharpening implements DemoImgOp{
    float matrix[] = {-1f,-1f,-1f,
                     -1f, 9f,-1f,
                     -1f,-1f,-1f};
    //objekt tridy ConvolveOp, jez je urcena pro konvolucni filtrovani
    protected ConvolveOp cop;
    //kostruktor, ktery podle pole matrix sestavi kernelovskou matici a inicializace objekt tridy ConvolveOp
    public Sharpening() {
        Kernel kernel = new Kernel(3,3,matrix);
        cop = new ConvolveOp(kernel, ConvolveOp.EDGE_NO_OP, null);
    }
    public BufferedImage filter(BufferedImage src){
        //metoda filter tridy ConvolveOp provadi vlastni filtrovani
    	return cop.filter(src, null);
    }
}
